//+------------------------------------------------------------------+
//|                                                   GridOnlyEA.mq4 |
//|                              Copyright 2020, oladseye@gmail.com. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "oladseye@gmail.com"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

input string  B="";//======Trade Setting======
extern double Lot = 0.01; // Initial Lot 
extern int Grid = 25; // Trade Cycle
input int Magicbuy = 9191; //MAGIC NO  BUY TRADES( 1)
input string commentbuy ="buy";//  EA COMMENTS FOR BUY TRADES_______
input int Magicsell =9010;//   MAGIC NO FOR SELL TRADES (2)
input string commentsell ="sell"; //   EA COMMENTS FOR SELL TRADES______ 
extern int    slippage = 3; //Slippage


double point;
bool isTrade = false;
bool issell =false;
bool isbuy =false;
int countTrade; 
double buyLastPrice;
double sellLastPrice;

int TicketList[];
double PriceList[];
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   if (Digits == 3 || Digits == 5){ point = 10.0 * Point;slippage = 3*10;}
   else point = Point;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
     if(TotalTrades(Magicbuy,Magicsell)==0){Print("initial total: ",TotalTrades(Magicbuy,Magicsell));First();}
     AddPrice();
     MaintainGrid();
     OpenTrades();
   
  }
  
//+------------------------------------------------------------------+


void First()
   {
     
     int ticket1;
     int ticket2;
     
     ticket1 = sendTrade(1, Lot, Bid, slippage, Ask, 0, 0, commentsell, Magicsell, 0, clrNONE);
     if (ticket1 < 0) {Print("Error: ", GetLastError()); return ; }
     
  
     ticket2 = sendTrade(0, Lot, Ask, slippage, Bid, 0, 0, commentbuy, Magicbuy, 0, clrNONE);
     if (ticket2 < 0) {Print("Error: ", GetLastError());return ; }
     
     
     double pricesell = GetPrice(ticket1);
     double pricebuy =  GetPrice(ticket2);
     double MidPrice;
     if(pricebuy !=0 && pricesell !=0)MidPrice = NormalizeDouble((pricebuy + pricesell)/2,Digits);
     
     
     Print("price array: ", ArraySize(PriceList));
     
     ArrayFree(PriceList);
     ArrayResize(PriceList,1);
     PriceList[0] = MidPrice;  
     AddPrice(0); 
   
   }



void  AddPrice(double mrice=0)
   {
     int n = 0;
     double Price;
     if(mrice == 0)Price =  PriceList[0];
     else 
      {
         Price = mrice;
         PriceList[0] = mrice;
      }   
         
     //if(ArraySize(PriceList)== 0) ArrayFree(PriceList);
     for (int i=1; i<=5; i++)
         {
                 int s = ArraySize(PriceList);
                 n=s+1;
                 ArrayResize(PriceList,n);
                 PriceList[s] = Price + (i * Grid * point);
             
         }
         
         
     for (int i=1; i<=5; i++)
         {
                 int s = ArraySize(PriceList);
                 n=s+1;
                 ArrayResize(PriceList,n);
                 PriceList[s] = Price + (-1 * i * Grid * point);
             
         }    
   
   }


void OpenTrades()
   {
     //double uppipsmid;
     //double upopipsmid;
     double openup;
     double opendw;
     bool go = false;
    
     
      
      for(int i=1; i<ArraySize(PriceList);i++)
         {
      
            //uppipsmid=(Close[0]- PriceList[i])/poin;
            //upopipsmid=(upopen-PriceList[i])/poin;
            //if(upopipsmid>TouchPips && uppipsmid<=TouchPips)
            
            openup=MathMin(Open[0],Close[1]);
            opendw=MathMax(Open[0],Close[1]);
            if(openup > PriceList[i] && Close[0] <= PriceList[i])go = true;
            if(opendw < PriceList[i] && Close[0] >= PriceList[i])go = true;
            
            if(go)
               {
                 Print("opened in others");
                 int ticket1 = sendTrade(1, Lot, Bid, slippage, Ask, 0, 0, commentsell, Magicsell, 0, clrNONE);
                 if (ticket1 < 0) Print("Error: ", GetLastError());
                 
                 int ticket2 = sendTrade(0, Lot, Ask, slippage, Bid, 0, 0, commentbuy, Magicbuy, 0, clrNONE);
                 if (ticket2 < 0) Print("Error: ", GetLastError());
                 
                 return;
               }
            
            
         }   
   }

void MaintainGrid()
   {
     if(Close[0]>= PriceList[5])AddPrice(PriceList[5]);
     if(Close[0]<= PriceList[10])AddPrice(PriceList[10]);
   
   
   
   
   
   }

int TotalTrades(int Magic1,int Magic2) {
   int count = 0;
   int tre = OrdersTotal();
   //Print("total: ", OrdersTotal());
   for (int pos = tre - 1; pos >= 0; pos--) 
     {
         if (OrderSelect(pos, SELECT_BY_POS, MODE_TRADES))
            {
              if (OrderSymbol()== Symbol() && (OrderMagicNumber() == Magic2 || OrderMagicNumber() == Magic1)){ count++;}
            }     
     }
   //Print("count sent: ", count);
   return (count);
}


double GetPrice(int tk)
   {
      if (OrderSelect(tk, SELECT_BY_TICKET))return(OrderOpenPrice());
      
   return(0);
   
   }

bool CheckList(double price)
   {
     
     bool stat = false;
     for (int i = ArraySize(PriceList) - 1; i >= 0; i--)
       {
            if(MathAbs(PriceList[i] - price)<= 1 * point)return(true);

         
       }
   return(false);
   }




bool CheckTrade(double price)
   {
     
     bool stat = true;
     for (int pos = OrdersTotal() - 1; pos >= 0; pos--)
       {
         //stat = false;
         if (OrderSelect(pos, SELECT_BY_POS, MODE_TRADES))
            {
                if (OrderSymbol()== Symbol())
                  {
                  
                     if (OrderMagicNumber() == Magicbuy || OrderMagicNumber() == Magicsell)
                        {
                           if (OrderType() == OP_SELL || OrderType() == OP_BUY) 
                              { 
                                //if(MathAbs(OrderOpenPrice() - ask)>= Grid * point && MathAbs(OrderOpenPrice() - bid)>= Grid * point)stat = true;
                                if(MathAbs(OrderOpenPrice() - price)<= 2 * point)return(false);
      
                              }
                        }
                   }    
               }
       }
   return(stat);
   }



double Last_Buy_Price(int MagicNumber) {
   double orderprice=0;
   int ticket1;
   double Ld_unused_12 = 0;
   int ticket2 = 0;
   for (int pos = OrdersTotal() - 1; pos >= 0; pos--) {
      if (OrderSelect(pos, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_BUY) {
         ticket1 = OrderTicket();
         if (ticket1 > ticket2) {
            orderprice = OrderOpenPrice();
            Ld_unused_12 = orderprice;
            ticket2 = ticket1;
         }
      }
   }
   return (orderprice);
}

double Last_Sell_Price(int MagicNumber) {
   double orderprice=0;
   int ticket1;
   double Ld_unused_12 = 0;
   int ticket2 = 0;
   for (int pos = OrdersTotal() - 1; pos >= 0; pos--) {
      if (OrderSelect(pos, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() != Symbol() || OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber && OrderType() == OP_SELL) {
         ticket1 = OrderTicket();
         if (ticket1 > ticket2) {
            orderprice = OrderOpenPrice();
            Ld_unused_12 = orderprice;
            ticket2 = ticket1;
         }
      }
   }
   return (orderprice);
}


int sendTrade(int ltype, double llot, double lprice, int lslip, double nprice, int lstoploss, int ltakeprofit, string lcomment, int lmagic, int ldate, color lcolor) {
   int lticket = 0;
   int lerror = 0;
   int lcount = 0;
   int lmax = 100;
   switch (ltype) {
   
   case 0:
      for (lcount = 0; lcount < lmax; lcount++) {
         RefreshRates();
         lticket = OrderSend(Symbol(), OP_BUY, llot, Ask, lslip, 0, 0, lcomment, lmagic, ldate, lcolor);
         lerror = GetLastError();
         if (lerror == 0/* NO_ERROR */) break;
         if (!((lerror == 4/* s_busy */ || lerror == 137/* B_busy */ || lerror == 146/* T_C_B */ || lerror == 136/* OFF_QUOTES */))) break;
         Sleep(5000);
      }
      break;
   case 1:
      for (lcount = 0; lcount < lmax; lcount++) {
         lticket = OrderSend(Symbol(), OP_SELL, llot, Bid, lslip, 0, 0, lcomment, lmagic, ldate, lcolor);
         lerror = GetLastError();
         if (lerror == 0/* NO_ERROR */) break;
         if (!((lerror == 4/* s_busy */ || lerror == 137/* B_busy */ || lerror == 146/* T_C_B */ || lerror == 136/* OFF_QUOTES */))) break;
         Sleep(5000);
      }
   }
   return (lticket);
}
